Browse Source

bisect: print an error message when "git rev-list --bisect-vars" fails

Before this patch no error was printed when "git rev-list --bisect-vars"
failed. This can happen when bad and good revs are mistaken.

This patch prints an error message on stderr that describe the likely
failure cause.

Signed-off-by: Christian Couder <chriscool@tuxfamily.org>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
maint
Christian Couder 17 years ago committed by Junio C Hamano
parent
commit
42ba5ee776
  1. 19
      git-bisect.sh
  2. 7
      t/t6030-bisect-porcelain.sh

19
git-bisect.sh

@ -220,18 +220,33 @@ bisect_auto_next() { @@ -220,18 +220,33 @@ bisect_auto_next() {
bisect_next_check && bisect_next || :
}

eval_rev_list() {
_eval="$1"

eval $_eval
res=$?

if [ $res -ne 0 ]; then
echo >&2 "'git rev-list --bisect-vars' failed:"
echo >&2 "maybe you mistake good and bad revs?"
exit $res
fi

return $res
}

filter_skipped() {
_eval="$1"
_skip="$2"

if [ -z "$_skip" ]; then
eval $_eval
eval_rev_list "$_eval"
return
fi

# Let's parse the output of:
# "git rev-list --bisect-vars --bisect-all ..."
eval $_eval | while read hash line
eval_rev_list "$_eval" | while read hash line
do
case "$VARS,$FOUND,$TRIED,$hash" in
# We display some vars.

7
t/t6030-bisect-porcelain.sh

@ -302,6 +302,13 @@ test_expect_success 'bisect refuses to start if branch new-bisect exists' ' @@ -302,6 +302,13 @@ test_expect_success 'bisect refuses to start if branch new-bisect exists' '
git branch -d new-bisect
'

test_expect_success 'bisect errors out if bad and good are mistaken' '
git bisect reset &&
test_must_fail git bisect start $HASH2 $HASH4 2> rev_list_error &&
grep "mistake good and bad" rev_list_error &&
git bisect reset
'

#
#
test_done

Loading…
Cancel
Save